if (typeof module !== 'undefined' &&
    typeof exports !== 'undefined' &&
    module.exports === exports) {
    module.exports = 'scanMan';
}

var app = angular.module("scanMan", ["ngWebSocket", "ngSanitize", "ui.toggle", "colorpicker"]);

app.controller('myCtrl', ['$scope', 'Messages', 'config', '$timeout', '$http', function ($scope, Messages, config, $timeout, $http) {


    $scope.Messages = Messages;

    $scope.viewType = "splash"; 
    $scope.modalTitle = "";
    $scope.qsDataInfo = "";
    $scope.closeButton = "Close";
    //console.log('initial collection ' + JSON.stringify(Messages.collection));
    $scope.responses = Messages.collection;
    $scope.configFac = Messages.gconfig;
    $scope.opticScan = function () {
        $scope.viewType = "splash";
        if (Messages.collection[0]) {
            Messages.collection[0].wsData.Scan.SpecialScan = "optic";
        }
        sessionStorage.removeItem("lastScan");
    }
    $scope.manualScan = function () {
        $scope.viewType = "manualView";
        if(Messages.collection[0]){
            Messages.collection[0].wsData.Scan.SpecialScan = "manual";
        }
        sessionStorage.removeItem("lastScan");
    }


    $scope.config = config;

    $scope.authenticatedUser = false;
    $scope.incorrectPass = false;
    $scope.authUsr = function (confcode) {
        Messages.send({
            MsgType: "ScanManualEntry",
            Entry: "SETCON" + confcode
        });
        $scope.confcode = null;
        $scope.incorrectPass = true;
        $timeout(function () {
            $scope.incorrectPass = false;
        }, 4000);
    }


    $scope.about = function () {
        $scope.viewType = "about";
        if (Messages.collection[0]) {
            Messages.collection[0].wsData.Scan.SpecialScan = "about";
        }
    };


    $scope.configuration = function () {
        sessionStorage.removeItem("lastScan");
        $scope.viewType = "configuration";
        $scope.qsDataInfo = "";
        $scope.GetStatus();
        $scope.getEntireIni();
        if (Messages.collection[0]) {
            Messages.collection[0].wsData.Scan.SpecialScan = "configuration";
            $scope.indexArr = Messages.settings[0].wsSettings.cstmArrLength;
        }
        if ($scope.qsSettings[0].wsSettings.ConfigCode == '*~*86e066687d2cc09fee7e502d5c762253' || $scope.qsSettings[0].wsSettings.ConfigCode == '0') {
            $scope.qsSettings[0].wsSettings.ConfigCode = "";
        }
        
    };

    $scope.qrCode = function () {
        sessionStorage.removeItem("lastScan");
        $scope.viewType = "qrCode";
        if (Messages.collection[0]) {
            Messages.collection[0].wsData.Scan.SpecialScan = "qrCode";
        }
        if ($scope.qsSettings[0].wsSettings.ConfigCode == '*~*86e066687d2cc09fee7e502d5c762253' || $scope.qsSettings[0].wsSettings.ConfigCode == '0') {
            $scope.qsSettings[0].wsSettings.ConfigCode = "";
        }
    };
    
    $scope.alertMsg = function () {
        var alertMessage = Messages.collection[0].wsData.Scan.Detail;
        if (alertMessage.indexOf("Inquiry Mode") == -1) {
            if (alertMessage.indexOf("Hotlist") == -1) {
                if ($scope.viewType != "qrCode") {
                   
                    $scope.configuration();
                }
                else {
                    $scope.qrCode();
                }
                $scope.getEntireIni();
            }
        }
    }

  
    $scope.loadView = function () {
        if (Messages.collection[0]) {
            if (Messages.collection[0].wsData.Scan.Entry.startsWith("W0RlYn")) {
                Messages.send({
                    MsgType: 'ScanManualEntry',
                    Entry: "SETINI64" + Messages.collection[0].wsData.Scan.Entry
                });

                //alert(Messages.collection[0].wsData.Scan.Entry)
            }
            else if (Messages.collection[0].wsData.Scan.Detail.endsWith("prefaced by 'OP'.")) {
                //$scope.viewType = "splash";
                $scope.opticScan();
            
            }
            else {
                $scope.viewType = "ScanResponseView";
                $scope.qsStatus = Messages.collection;
            }
        }
        
    }
       





    $scope.testSocket = function () {
        //Messages.collection[0].Entry = "testSocket";
    }

    
    $scope.Status = Messages;
 

    $scope.Sounds = [
            { id: '1', name: 'True' },
            { id: '0', name: 'False' }
    ]

    $scope.onClose = function () {
        Messages.close(true);

    };

    $scope.onReconnect = function () {        
        Messages.reconnect();
    };


    $scope.onOpen = function () {
        Messages.open();
        //console.log("Message: " + Messages)
    };

    $scope.MsgType = 'ScanManualEntry';


    $scope.$watch('responses', function (oldvalue, newvalue) {
        $scope.animateIcon();
        //$scope.getConfig();     

        if (!$scope.qsStatus){
            $scope.qsStatus = Messages.collection;
            //$scope.Operator.settingValue = $scope.qsStatus[0].wsData.StatusResponse.Operator
            //console.log($scope.qsStatus)
        }
        

        //}       

    },true)


    $scope.animateIcon = function () {
        $scope.addAnimateBad = 'animated shake';
        $scope.addAnimateGood = 'animated bounceIn';
        $timeout(function () {
            $scope.addAnimateBad = "";
            $scope.addAnimateGood = "";
        }, 500);
    }

    $scope.toggle = function () {
        $scope.state = !$scope.state;
    };

    $scope.ResetScanCount = function () {
        Messages.send({
            MsgType: "SimpleCmd",
            CmdName: 'RESETCOUNT',
            args: {}
        });
       
        $scope.viewType = "splash";
        if (Messages.collection[0]) {
            Messages.collection[0].wsData.Scan.SpecialScan = "configuration";
        }
        $scope.GetStatus();
        
    };

    $scope.clearEmail = function () {
        Messages.send({
            MsgType: 'SimpleCmd',
            CmdName: 'CLEAREMAIL',
            args: {}
        });
        document.getElementById("msgButton").style.display = "none";
    }
    $scope.quit = function () {
        Messages.send({
            MsgType: 'SimpleCmd',
            CmdName: 'QUIT',
            args: {}
        });
    }

    $scope.getConfig = function () {
        Messages.send({
            MsgType: 'GetConfig'
        });    
        $scope.qsConfig = Messages.gconfig;
    }

    $scope.getEntireIniCmd = function () {
        //Messages.send({
        //    MsgType: 'SimpleCmd',
        //    MsgId:"9999",
        //    CmdName:"GETENTIREINI"
        //});

        Messages.send({
            MsgType: 'SimpleCmd',
            MsgId: "9999",
            CmdName: "GETINI64"
        });

        if (Messages.gdataInfo[0]) {

            var cleanStr = Messages.gdataInfo[0].wsDataInfo.Msg;
            //cleanStr = encodeURI(cleanStr);
            //cleanStr = decodeURI(cleanStr.replace(/%5C/g, "%5C%5C"));

            //cleanStr = cleanStr.replace(/\\/g, "\\\\");
            //cleanStr = cleanStr.replace(/\\"/g, '\\\"');
            //cleanStr = cleanStr.replace(/[\r\n]/g, ' ');
            //cleanStr = cleanStr.replace(/\\\\/g, '\\');

            $scope.qsDataInfo = cleanStr;



            console.dir($scope.qsDataInfo);
        }
    }


    $scope.setEntireIniCmd = function () {
        //Messages.send({
        //    MsgType: 'SimpleCmd',
        //    Entry: "SETENTIREINI" + $scope.qsDataInfo
        //});
        Messages.send({
            MsgType: 'ScanManualEntry',
            Entry: "SETINI64" + $scope.qsDataInfo
        });
      

    }

    $scope.getEntireIni = function () {
        Messages.send({
            MsgType: 'GetIniCmd'
        });
        $scope.qsSettings = Messages.settings;
        //console.dir($scope.qsSettings);
    }
    $scope.getIniCmd = function () {
        Messages.send({
            MsgType: 'GetIniCmd',
            Section: 'GUI'
        });

    }




    $scope.getSounds = function () {
        Messages.send({
            MsgType: "GetFileListCmd",
            SubDir: "Sounds"           
        });
        $scope.Sounds = Messages.sounds;
        //console.dir(Messages.sounds);
    }

    $scope.setNewIni = function () {
        Messages.send({
            MsgType: 'SetIniCmd',
            ReloadIni: 'true',
            settings: [{"Section":"GUI","Key":"CountMax","Value":"20"}]
        });
         $scope.qsConfig = Messages.gconfig;
    }


    $scope.getMessage = function () {
        $scope.modalTitle = "Message";
    }
    $scope.expandPassPhoto = function () {
        $scope.modalTitle = "Pass Photo";
        $scope.closeButton = "Close";
    }

    $scope.getOnline = function () {
        $scope.modalTitle = "Reconnect";
        $scope.closeButton = "Cancel";
    }

    $scope.getOffline = function () {
        $scope.modalTitle = "Force Offline";
        $scope.closeButton = "Cancel";
    }
    $scope.forceOnline = function () {
        Messages.send({
            MsgType: 'SimpleCmd',
            CmdName: 'RECONNECT',
            args: {'force':'1'}
        });
        $scope.GetStatus();
    }

    $scope.getCounter = function () {
        $scope.modalTitle = "Reset Counter";
        $scope.closeButton = "Cancel";
    }
    $scope.getPassDetail = function () {
        $scope.modalTitle = "Pass Information";
        $scope.closeButton = "Close";
        Messages.send({
            MsgType: 'SimpleCmd',
            CmdName: 'GETPASSDETAIL',
            args: {}
        });
    }

    $scope.getScanHistory = function () {
        $scope.modalTitle = "Scan History";
        $scope.closeButton = "Close";
        Messages.send({
            MsgType: 'SimpleCmd',
            CmdName: 'GETSCANHISTORY',
            args: {}
        });
    }

    $scope.GetStatus = function () {
        //Setting this scope (msgType) will change the view based on the ng-if in index.html
        $scope.msgType = "GetStatus";
        Messages.send({
            MsgType: 'GetStatus'
        });
        $scope.qsStatus = Messages.gstatus;
        console.log($scope.qsStatus)
        
    };

    if ($scope.responses.length < 1) {
        $scope.GetStatus();
        $scope.getConfig();
        $scope.getEntireIni();
        $scope.getSounds();
    }


  


    $scope.toggleInquiry = function (inqVal) {
        $scope.viewType = "splash";
        Messages.collection[0] = "";
        var tVal = "";
        if (inqVal == true) {
            tVal = 0;
        }
        else if (inqVal == false) {
            tVal = 1;
        }
        Messages.send({
            MsgType: $scope.MsgType,
            Entry: "SETINQ" + tVal
        });
        $scope.qsStatus = Messages.collection;
    };



    //MP: Not sure if we should change the name of this function or 
    $scope.sendTxt = function (manualEntry) {
        manualEntry = manualEntry.toUpperCase();
        $scope.viewType = "ScanResponse";
        Messages.send({
            MsgType: $scope.MsgType,
            Entry: manualEntry
        });
        $scope.manualEntry = "";

        //console.log(Messages)
        
    };
    var selectedAutoSaleItems = [];


    $scope.clearAutoSale = function () {
        selectedAutoSaleItems = [];
    }

    $scope.getAutoSaleCount = function (start, end) {

        var temp = [];
        for (var i = start; i <= end; i++) {
            temp.push(i);
        }
        return temp;
    }
    $scope.selectedMax = 0;

    
    $scope.setQty = function (items, selectedMax) {
        var currentSelectedAuto = { 'Descrip':  items.Descrip, 'DCI' : items.DCI, 'Qty': selectedMax }
        //selectedAutoSaleItems.push(currentSelectedAuto);
        if (selectedAutoSaleItems.length > 0) {
            var index = selectedAutoSaleItems.findIndex(x => x.DCI == currentSelectedAuto.DCI)
            // here you can check specific property for an object whether it exist in your array or not

            if (index === -1) {
                selectedAutoSaleItems.push(currentSelectedAuto);
            }
            else {
                selectedAutoSaleItems[index] = currentSelectedAuto;
            }
         
        } else {
            selectedAutoSaleItems.push(currentSelectedAuto);
        }
        



        $scope.selectedAutoSaleItems = selectedAutoSaleItems;
        //console.log()
        //selectedAutoSaleItems = [];
    }


    $scope.sendAutoSale = function () {
        if (!$scope.selectedAutoSaleItems) {
            $scope.selectedAutoSaleItems = [{ 'Descrip': Messages.collection[0].wsData.AutoSale.items[0].Descrip, 'DCI': Messages.collection[0].wsData.AutoSale.items[0].DCI, 'Qty': 0 }];
        }       
        Messages.send({
            MsgType: $scope.MsgType,
            AutoSale: { 'items': $scope.selectedAutoSaleItems },
            Entry: Messages.collection[0].wsData.Scan.Entry
        });
       
        //console.dir(selectedAutoSaleItems);
        $scope.selectedAutoSaleItems = "";       
    };


    $scope.updateSetting = function (obj) {
        
        var setVal = "";
        if (obj.selectedOption) {
            if (obj.selectedOption.length > 1) {
                for (i = 0; i < obj.selectedOption.length; i++) {
                    setVal += '*' + obj.selectedOption[i].id + '*, ';
                }
                setVal = setVal.replace(/,\s*$/, "");
                //setVal = obj.selectedOption;
            }else{
                setVal = obj.selectedOption.id;
            }
        } else {
            setVal = obj.settingValue;
        }
        if (!obj.reloadIni) { obj.reloadIni = "false"}
        Messages.send({
            MsgType: 'SetIniCmd',
            ReloadIni: obj.reloadIni,
            settings: [{
                "Section": obj.section,
                "Key": obj.settingID,
                "Value": setVal
            }]
        });
        $scope.GetStatus();
        $scope.getEntireIni();
        $scope.settingsMsg = true;
        $scope.saveMsg = obj.settingLabel + ": " + setVal;
    }


    $scope.updateSettingCstm = function (obj) {
        //console.dir(obj)

        Messages.send({
            MsgType: 'SetIniCmd',
            ReloadIni: obj.reloadIni,           
            settings: [{ "Section": obj.section, "Key": "DCI", "Value": obj.settingValue }, { "Section": obj.section, "Key": "GoodSound", "Value": obj.selectedOptionGood.id }, { "Section": obj.section, "Key": "BadSound", "Value": obj.selectedOptionBad.id }, { "Section": obj.section, "Key": "Custom", "Value": "{\\\"DCI_bkgd_color\\\":\\\"" + obj.background + "\\\",\\\"DCI_font_color\\\":\\\"" + obj.font + "\\\"}" }]
        });
        //$scope.GetStatus();
        $scope.getEntireIni();
        $scope.settingsMsg = true;
        $scope.saveMsg = obj.settingLabel;
        //$scope.modelsrc = "";
        //$scope.soundsrc = "";
    }

    $scope.clearSettingCstm = function (section) {
        //console.dir(section)

        Messages.send({
            MsgType: 'SetIniCmd',
            ReloadIni: true,
            settings: [{ "Section": section, "Key": "DCI", "Value": "" }, { "Section": section, "Key": "GoodSound", "Value": ""}, { "Section": section, "Key": "BadSound", "Value": "" }, { "Section": section, "Key": "Custom", "Value": "" }]
        });
        //$scope.GetStatus();
        $scope.getEntireIni();
        $scope.settingsMsg = true;
        $scope.saveMsg = "Removed";

    }


    $scope.updateConfig = function (obj) {
        $scope.viewType = "scanResponse";
        if (obj.selectedOption) {
            var setVal = obj.selectedOption.name;
            var selOpt = obj.selectedOption.id;
            if (selOpt == "true") {                
                selOpt = 1
            } else if (selOpt == "false") {                
                selOpt = 0
            }
        Messages.send({
            MsgType: $scope.MsgType,
            Entry: obj.settingFunc + selOpt
        });
        } else {
            var setVal = obj.settingValue.toString();
            Messages.send({
                MsgType: $scope.MsgType,
                Entry: obj.settingFunc + obj.settingValue.toString()
            });
        }
        $scope.manualEntry = "";
        $scope.getConfig();
        $scope.qsStatus = Messages.collection;
        $scope.settingsMsg = true;
        $scope.saveMsg = obj.settingLabel + ": " + setVal;     
    };

    $scope.IP = {
        section: "Preferences",
        reloadIni: "true",        
        typeSet: "text",
        info: "Set the IP address of the SalesEZ / Middleware Server.",
        settingLabel: "IP",
        settingID: "IP",
        settingValue: config.IP,
        settingFunc: "SETIP",
        availableOptions: [],
    }
    $scope.Port = {
        section: "Preferences",
        reloadIni: "true",
        typeSet: "number",
        info: "Set the port number of the SalesEZ / Middleware Server. SalesEZ Live = 4203, SalesEZ Training = 4205, Middleware Live = 4222, Middleware Training = 4223.",
        settingLabel: "Port",
        settingID: "Port",
        settingValue: config.Port,
        settingFunc: "SETPORT",
        availableOptions: [],
    }
   

    $scope.Operator = {
        section: "Preferences",
        typeSet: "text",
        info: "Enter the Operator name to be used with this device. Note: an operator barcode can also be scanned to set this setting.",
        settingLabel: "Operator",
        settingID: "Unit",
        settingValue: config.Operator,
        settingFunc: "SETOP",
        availableOptions: []
    }

    $scope.AutoOp = {
        section: "Preferences",
        typeSet: "text",
        reloadIni: "true",
        allowClear: "true",
        info: "Enter the Operator name to be used with this device. ",
        settingLabel: "Auto Operator",
        settingID: "AutoOp",
        settingValue: config.AutoOp,
        settingFunc: "SETAUTOOP",
        availableOptions: []
    }



    $scope.InquiryModeExit = {
        section: "Preferences",
        info: "If set to True, after perfoming an inquiry scan, QuickScan will automatically revert back to the non inquiry scanning mode. If set to False, QuickScan will continue to Inquiry Scan until the user hits the Inquity button.",
        settingLabel: "Inquiry Mode Exit",
        settingID: "InqExit",
        settingValue: config.InquiryModeExit,
        settingFunc: "SETINQEXIT",
        availableOptions: [
            { id: '1', name: 'True' },
            { id: '0', name: 'False' }
        ],
        selectedOption: { id: config.InquiryModeExit }
    }

    $scope.InquiryModeLock = {
        section: "Preferences",
        info: "If set toTrue, this would prevent QuickScan from being used for anything other than inquiry.",
        settingLabel: "Inquiry Mode Lock",
        settingID: "InqLock",
        settingValue: config.InquiryModeLock,
        settingFunc: "SETINQLOCK",
        availableOptions: [
            { id: '1', name: 'True' },
            { id: '0', name: 'False' }
        ],
        selectedOption: { id: config.InquiryModeLock }
    }

    $scope.InquiryBkgd = {
        section: "GUI",
        reloadIni: "true",
        info: "Set the background color to show on all inquiry scans.",
        settingLabel: "Inquiry Mode Background",
        settingID: "InqBkgd",
        settingValue: config.InqBkgd,
        settingFunc: "InqBkgd",
        availableOptions: [
            { id: '1', name: 'True' },
            { id: '0', name: 'False' }
        ],
        selectedOption: { id: config.InquiryBkgd }
    }


    $scope.InqDisable = {
        section: "GUI",
        reloadIni: "true",
        info: "Set to True to hide the Inquiry button if you do not intend to perform inquiries with this scanner.",
        settingLabel: "Inquiry Mode Disable",
        settingID: "InqDisable",
        settingValue: config.InqDisable,
        settingFunc: "InqDisable",
        availableOptions: [
            { id: '1', name: 'True' },
            { id: '0', name: 'False' }
        ],
        selectedOption: { id: config.InqDisable }
    }

    $scope.CounterActive = {
        section: "Preferences",
        info: "Set to True to active the scan counter shown on the bottom. The counter can be reset by tapping on the Count button. Set Counter Bar to 0 to display as a whole number instead of X of X.",
        settingLabel: "Counter Active",
        settingID: "Cntr",
        settingValue: config.CounterActive,
        settingFunc: "SETCNTR",
        availableOptions: [
            { id: '1', name: 'True' },
            { id: '0', name: 'False' }
        ],
        selectedOption: { id: config.CounterActive }
    }
    $scope.CounterBar = {
        section: "GUI",
        typeSet: "number",
        info: "If set to a number other than 0 or blank, the Counter Progress bar will be shown with the max number set in this setting. Useful for operations where limited number of people can enter at a time.",
        settingLabel: "Counter Bar",
        settingID: "CounterBar",
        settingValue: config.CounterBar,
        settingFunc: "",
        availableOptions: []
    }
    $scope.cpn = {
        section: "GUI",
        typeSet: "text",
        info: "Set the checkpoint name to be shown in the Facility Count report.",
        settingLabel: "Checkpoint Name",
        settingID: "cpn",
        settingValue: config.cpn,
        settingFunc: "",
        availableOptions: []
    }
    $scope.cpv = {
        section: "GUI",
        reloadIni: "true",
        info: "Set the checkpoint value to IN is the scanner is used at the entrance or OUT if used at the exit for the Facility.",
        settingLabel: "Checkpoint Value",
        settingID: "cpv",
        settingValue: config.cpv,
        settingFunc: "cpv",
        availableOptions: [
            { id: ' ', name: '--No Value--' },
            { id: 'IN', name: 'IN' },
            { id: 'OUT', name: 'OUT' }
        ],
        selectedOption: { id: config.cpv }
    }
    $scope.Verbosity = {
        section: "Preferences",
        typeSet: "number",
        info: "Set the level of detail to be collected in the log file. 0 is no log collection and 5 is detailed log collection.",
        settingLabel: "Log Verbosity",
        settingID: "VerbosityLevel",
        settingValue: config.Verbosity,
        settingFunc: "SETLOG",
        availableOptions: []
    }
    $scope.RolloverMonth = {
        settingLabel: "Rollover Month",
        typeSet: "text",
        info: "The number of the month to begin valid scans, regardless of year. Used when the date is encrypted into the barcode without a year. ",
        settingID: "RolloverMonth",
        settingValue: config.RolloverMonth,
        settingFunc: "SETROLL",
        availableOptions: []
    }

    $scope.TrickleInterval = {
        section: "Preferences",
        typeSet: "number",
        info: "Time to wait (in tenths of seconds) between each trickle (offline scan) to be sent to SalesEZ / Middleware in order to avoid overloading the trickle thread. Recomended to be set to 30 (3 seconds).",
        settingLabel: "Trickle Interval",
        settingID: "TrickleInterval",
        settingValue: config.TrickleInterval,
        settingFunc: "SETTI",
        availableOptions: []
    }
    $scope.SalesEZTimeout = {
        section: "Preferences",
        typeSet: "number",
        info: "Number of seconds (in tenths of seconds) to wait until QuickScan determines it is offline after it realizes it is not initially connected. Recommended to be set to 30 (3 Seconds)",
        settingLabel: "SalesEZ Timeout",
        settingID: "SalesEZTimeout",
        settingValue: config.SalesEZTimeout,
        settingFunc: "SETTO",
        availableOptions: []
    }
    $scope.ReconnectScanInterval = {
        section: "Preferences",
        typeSet: "number",
        info: "If QuickScan is currently offline, this is the number of scans to wait until a reconnect is attempted. Recomended to be set to 25",
        settingLabel: "Reconnect Scan Interval",
        settingID: "ReconnectScanInterval",
        settingValue: config.ReconnectScanInterval,
        settingFunc: "SETRECINT",
        availableOptions: []
    }
    $scope.GuestInfoText = {
        section: "Preferences",
        typeSet: "text",
        info: "Guest, Ticket, and Pass information to appear after a good or bad scan occurs.",
        settingLabel: "Guest Info",
        settingID: "GuestInfoText",
        settingValue: config.GuestInfoText,
        settingFunc: "SETGITEXT",
        availableOptions: []
    }
    $scope.UseExpirationDates = {
        section: "Preferences",
        info: "If encoding the expiration date on the barcode, set to True to check to ensure the date has not expired.",
        settingLabel: "Use Expiration Dates",
        settingID: "UseExpirationDates",
        settingValue: config.UseExpirationDates,
        settingFunc: "SETEXP",
        availableOptions: [
            { id: '1', name: 'True' },
            { id: '0', name: 'False' }
        ],
        selectedOption: { id: config.UseExpirationDates }
    }

    $scope.ConfigCode = {
        section: "Preferences",
        typeSet: "number",
        info: "Set a security passcode to disable unauthorized access to settings. Set to 0 to disable the passcode prompt and allow any user to access settings.",
        reloadIni: "true",
        settingLabel: "Security Passcode",
        settingID: "ConfigCode",
        settingValue: config.ConfigCode,
        settingFunc: "SETRECINT",
        availableOptions: []
    }


    $scope.Language = {
        settingLabel: "Language",
        info: "Which Language you would like to use.",
        settingID: "Language",
        settingValue: config.Language,
        settingFunc: "SETLANG",
        availableOptions: [
            { id: 'ENGLISH', name: 'English' },
            { id: 'SPANISH', name: 'Spanish' }
        ],
        selectedOption: { id: config.Language }
    }
    $scope.SalesPoint = {
        section: "Preferences",
        typeSet: "text",
        info: "Enter the SalesPoint name that is confgured as a QuickScan SalesPoint. Ensure this is unique for this device and not used by another device.",
        settingLabel: "SalesPoint",
        settingID: "Unit",
        settingValue: config.SalesPoint,
        settingFunc: "SETID",
        availableOptions: []
    }

    $scope.ScanResponseField = {
        section: "GUI",
        info: "Guest, Ticket, and Pass information to appear after a good or bad scan occurs.",
        settingLabel: "ScanResponse Fields",
        settingID: "ScanResponseField",
        settingValue: config.SalesPoint,
        settingFunc: "SETID",
        availableOptions: [
            { id: 'GUEST_NAME', name: 'Guest Name' },
            { id: 'GUEST_NAME2', name: 'Second Guest' },
            { id: 'MESSAGE', name: 'Guest Message' },
            { id: 'HEIGHT', name: 'Height' },
            { id: 'AGE', name: 'Age' },
            { id: 'BIRTHDATE', name: 'Birthdate' },
            { id: 'SCAN_NO', name: 'Scan Number' },
            { id: 'PASS_NO', name: 'Pass Number' },
            { id: 'ITEM_DESCRIP', name: 'Item Description' },
            { id: 'CUSTOMER_TYPE', name: 'Customer Type' },
            { id: 'DCI', name: 'DCI' },
            { id: 'USES', name: 'Total Uses' },
            { id: 'START_DATE', name: 'Start Date' },
            { id: 'EXP_DATE', name: 'Expiration Date' },
            { id: 'POINTS1', name: 'Points 1' },
            { id: 'POINTS2', name: 'Points 2' },
            { id: 'MONEY1', name: 'Money 1' },
            { id: 'MONEY2', name: 'Money 2' }
            //{ id: 'EMAIL', name: 'Email' }
        ],
        selectedOption: { id: 'TICKET1', name: 'TICKET1' }
    }

    $scope.DateFormat = {
        settingLabel: "DateFormat",
        settingID: "DateFormat",
        settingValue: config.DateFormat,
        settingFunc: "",
        availableOptions: [
            { id: 'mm/dd/yyyy', name: 'mm/dd/yyyy' },
            { id: 'dd/mm/yyyy', name: 'dd/mm/yyyy' }
        ],
        selectedOption: { id: config.SalesPoint }
    }
    
    $scope.Location = {
        settingLabel: "Location",
        info: "Set the valid access control location number(s) for this device to control which tickets and passes can be scanned. Note: Multiple locations can be set seperated by comma, for example LOC1, LOC2, LOC3",
        typeSet: "text",
        settingID: "Location",
        settingValue: config.Location,
        settingFunc: "SETLOC",
        availableOptions: []
    }

    $scope.AutoLoc = {
        section: "Preferences",
        settingLabel: "Auto Location",
        reloadIni: "true",
        allowClear: "true",
        info: "Set the valid access control location number(s) for this device to control which tickets and passes can be scanned. Note: Multiple locations can be set seperated by comma, for example LOC1, LOC2, LOC3",
        typeSet: "text",
        settingID: "AutoLoc",
        settingValue: config.AutoLoc,
        settingFunc: "SETAUTOLOC",
        availableOptions: []
    }


    $scope.LockKey = {
        section: "Preferences",
        settingLabel: "Clear LockKey",
        reloadIni: "true",
        allowClear: "true",
        info: "This setting will refresh the application and clear the LockKey",
        typeSet: "text",
        settingID: "LockKey",
        settingValue: config.LockKey,
        settingFunc: "Reconnect",
        availableOptions: []
    }

    $scope.ValidationItem = {
        section: "Preferences",
        reloadIni: "true",
        allowClear: "true",
        settingLabel: "Validation Item",
        info: "This setting causes scans to use the validation template for the item listed here to inquire as to whether the pass or ticket would be valid. DCI is padded to 30 characters",
        typeSet: "text",
        settingID: "DCI",
        settingValue: config.DCI,
        settingFunc: "SETDCI",
        availableOptions: []
    }


    $scope.AllowedSiteID = {
        section: "Preferences",
        reloadIni: "true",
        allowClear: "true",
        settingLabel: "Allowed Site ID",
        info: "Set the allowable Site ID's to be scanned. Multiple site IDs can be set with a comma, for example 1,2. Passes that do not have a correct site ID get a 'Bad Barcode' message when scanned.",
        typeSet: "text",
        settingID: "AllowedSiteID",
        settingValue: config.AllowedSiteID,
        settingFunc: "SETDCI",
        availableOptions: []
    }

    $scope.Prepend = {
        section: "Preferences",
        reloadIni: "true",
        allowClear: "true",
        settingLabel: "Prepend Scan",
        info: "This setting causes all barcodes scanned to be pre-pended with the prefix specified. For example A999 becomes A111999. Note: Multiple values can be set seperated by a semicolon For example A,111; ,222; B875,333",
        typeSet: "text",
        settingID: "Prepend",
        settingValue: config.Prepend,
        settingFunc: "SETPREPEND",
        availableOptions: []
    }

    $scope.Extract = {
        section: "Preferences",
        reloadIni: "true",
        allowClear: "true",
        settingLabel: "Extract Scan",
        info: "Set which values to extract based on the length of the scan. For example, 10,1,2 where three numbers must be specified in the setting: 10 is the legth to look for, 1 is the character to begin extraction, and 2 is the number of characters to extract. If 0123456789 were to be scanned, 12 would be extracted. This setting can take multiple values with a semicolon seperator, for example 10,1,2;11,2,3",
        typeSet: "text",
        settingID: "Extract",
        settingValue: config.Extract,
        settingFunc: "SETEXTRACT",
        availableOptions: []
    }

    $scope.NoDec = {
        section: "Preferences",
        reloadIni: "true",
        allowClear: "true",
        settingLabel: "No Decrypt Prefixes",
        info: "Causes a barcode to not be decrypted when prefixed by something in this list. For example, if scans prefixed with A and P should not decrypted, the setting would be AP",
        typeSet: "text",
        settingID: "NoDec",
        settingValue: config.NoDec,
        settingFunc: "SETNODEC",
        availableOptions: []
    }

    $scope.NfcPrefix = {
        section: "Preferences",
        reloadIni: "true",
        allowClear: "true",
        settingLabel: "RFID/NFC Prefix TEST",
        info: "Set the prefix configured in the prefixes table to determine which field QuickScan should point to when RFID media is read.",
        typeSet: "text",
        settingID: "NfcPrefix",
        settingValue: config.NfcPrefix,
        settingFunc: "SETNFCPREFIX",
        availableOptions: []
    }
    $scope.Card = {
        section: "GUI",
        typeSet: "text",
        info: "Set the Card Prefix as needed.",
        settingLabel: "Card Prefix",
        settingID: "Card",
        settingValue: config.Card,
        settingFunc: "",
        availableOptions: []
    }
    $scope.MaxBytes = {
        section: "RF",
        reloadIni: "true",
        allowClear: "true",
        info: "This setting is used to determine how many bytes of RFID media's UID are read when scanned. If set to 0, then it is disabled.",
        settingLabel: "Max Bytes",
        settingID: "MaxBytes",
        settingValue: config.MaxBytes,
        settingFunc: "",
        availableOptions: [
            { id: '0', name: '0' },
            { id: '4', name: '4' },
            { id: '5', name: '5' },
            { id: '6', name: '6' },
            { id: '7', name: '7' }
        ],
        selectedOption: { id: config.MaxBytes }
    }    

    $scope.ReadAsHex = {
        section: "RF",
        reloadIni: "true",
        allowClear: "true",
        info: "If set to True: This setting reads the hexadecimal value when the media is scanned. If set to False,: This setting will only read decimal values when media is scanned.",
        settingLabel: "Hexidecimal Value",
        settingID: "ReadAsHex",
        settingValue: config.ReadAsHex,
        settingFunc: "",
        availableOptions: [
            { id: '1', name: 'True' },
            { id: '0', name: 'False' }
        ],
        selectedOption: { id: config.ReadAsHex }
    }     
	
	$scope.DefaultRFIDStartBlock = {
        section: "RF",
        reloadIni: "true",
        allowClear: "true",
        info: "This setting is used to configure the RFID reader START block when processing tag scans.",
        settingLabel: "Default RFID Start Block",
        settingID: "DefaultRFIDStartBlock",
        settingValue: config.DefaultRFIDStartBlock,
        settingFunc: "",
        availableOptions: [
			{ id: '-1', name: '-1' },
            { id: '1', name: '1' },
            { id: '2', name: '2' },
            { id: '3', name: '3' },
            { id: '4', name: '4' },
			{ id: '5', name: '5' },
            { id: '6', name: '6' },
            { id: '7', name: '7' },
			{ id: '8', name: '8' }],
        selectedOption: { id: config.DefaultRFIDStartBlock }
	}
		
	$scope.DefaultRFIDEndBlock = {
        section: "RF",
        reloadIni: "true",
        allowClear: "true",
        info: "This setting is used to configure the RFID reader END block when processing tag scans.",
        settingLabel: "Default RFID End Block",
        settingID: "DefaultRFIDEndBlock",
        settingValue: config.DefaultRFIDEndBlock,
        settingFunc: "",
        availableOptions: [	
		    { id: '-1', name: '-1' },
            { id: '1', name: '1' },
            { id: '2', name: '2' },
            { id: '3', name: '3' },
            { id: '4', name: '4' },
			{ id: '5', name: '5' },
            { id: '6', name: '6' },
            { id: '7', name: '7' },
			{ id: '8', name: '8' }],
        selectedOption: { id: config.DefaultRFIDEndBlock }
	}

    $scope.GoodLive = {
        section: "Sounds",
        info: "Audio file for a Good Scan while online",
        reloadIni: "true",
        settingLabel: "Good Live",
        settingID: "GoodLive",
        settingValue: config.InquiryModeExit,
        availableOptions: [],
        selectedOption: {}
    }

    $scope.BadLive = {
        section: "Sounds",
        info: "Audio file for Bad Scan while online.",
        reloadIni: "true",
        settingLabel: "Bad Live",
        settingID: "BadLive",
        settingValue: config.InquiryModeExit,
        availableOptions: [],
        selectedOption: {}
    }
    $scope.GoodOff = {
        section: "Sounds",
        info: "Audio file for Good Scan while offline.",
        reloadIni: "true",
        settingLabel: "Good Offline",
        settingID: "GoodOff",
        settingValue: config.InquiryModeExit,
        availableOptions: [],
        selectedOption: {}
    }
    $scope.BadOff = {
        section: "Sounds",
        info: "Audio file for bad sound while offline",
        reloadIni: "true",
        settingLabel: "BadOff",
        settingID: "BadOff",
        settingValue: config.InquiryModeExit,
        availableOptions: [],
        selectedOption: {}
    }
    $scope.SpecialScan = {
        section: "Sounds",
        info: "Sound for special scan such as settings saved.",
        reloadIni: "true",
        settingLabel: "Special Scan",
        settingID: "SpecialScan",
        settingValue: config.InquiryModeExit,
        availableOptions: [],
        selectedOption: {}
    }
    $scope.Connect = {
        section: "Sounds",
        info: "Audio file for connection of device",
        reloadIni: "true",
        settingLabel: "Connect",
        settingID: "Connect",
        settingValue: config.InquiryModeExit,
        availableOptions: [],
        selectedOption: {}
    }
    $scope.Disconnect = {
        section: "Sounds",
        info: "Audio file for disconnection of device.",
        reloadIni: "true",
        settingLabel: "Disconnect",
        settingID: "Disconnect",
        settingValue: config.InquiryModeExit,
        availableOptions: [],
        selectedOption: {}
    }
    $scope.Email = {
        section: "Sounds",
        info: "Audio file for E-Message.",
        reloadIni: "true",
        settingLabel: "E-Message",
        settingID: "Email",
        settingValue: config.InquiryModeExit,
        availableOptions: [],
        selectedOption: {}
    }
        $scope.CustomDci = {
            info: "Set the Scan Response sound, background color, and font color based on a D, C, and or I that is scanned. The DCI field can contain parts of the department, category, or item. For example, if setting a custom DCI for all items in the dept TICKETS and cat ADMISSIONS, the DCI setting would be TICKETSADMISSIONS.",
            newSection: $scope.indexArr,
            reloadIni: "true",
            settingLabel: "CustomDci",
            settingID: "CustomDci",
            settingValue: config.CustomDci,
            availableOptions: [],
            selectedOption: {}
        }
 


    $scope.settingModeVal = "Operator";
    $scope.settingMode = function (settingVal) {
        $scope.settingModeVal = settingVal;        
    }

    $scope.settingModeCstm = function (settingVal, $index, isNew) {
        $scope.settingModeVal = settingVal;
        $scope.currIndx = $index;
        if (isNew) {
            //console.log("new")
            $scope.modelsrc = "";
           // $scope.soundsrc = "";
        }

    }
}])


app.filter('yesOrNo', function() {
    return function(input) {
        return input === 'true' ? 'yes' : 'no' ;
    };
})
app.filter('split', function() {
    return function(input, splitChar, splitIndex) {
        // do some bounds checking here to ensure it has that index
        return input.split(splitChar)[splitIndex];
    }
})
app.directive('stringToNumber', function() {
    return {
        require: 'ngModel',
        link: function(scope, element, attrs, ngModel) {
            ngModel.$parsers.push(function(value) {
                return '' + value;
            });
            ngModel.$formatters.push(function(value) {
                return parseFloat(value);
            });
        }
    };
});
app.directive('textBoxControl', function () {

    var template = '<form name="settings"><div ng-if="ctrl.availableOptions.length == 0"><div class="modal-body">{{ctrl.settingLabel}}: <span>{{modelsrc}}</span>' +
   '<input ng-show="ctrl.typeSet ==\'number\'" type="number" string-to-number class="form-control" ng-model="modelsrc" name="inptField" required><input ng-show="ctrl.typeSet ==\'text\'" type="text" name="inptField" class="form-control" ng-model="modelsrc" required><p class="alert alert-danger" ng-show="settings.inptField.$error.required">Input field must have a value.</p><p><em>{{ctrl.info}}</em></p><div class="alert alert-warning" ng-show="ctrl.reloadIni == \'true\'"><strong>Warning!</strong> This setting requires a restart to take effect.</div></div>' +
   '<div class="modal-footer"><button type="button" class="btn btn-danger" ng-click="clearModel()" ng-show="ctrl.allowClear == \'true\'">Clear</button><button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button><button class="btn btn-primary" ng-show="!settings.inptField.$error.required" type="button" ng-click="updateConfigObj(modelsrc)">Save</button></span></div></div></form>' +
   //'<div ng-if="ctrl.availableOptions.length > 1"><div class="modal-body"> <select class="form-control" name="repeatSelect" id="repeatSelect" ng-model="ctrl.selectedOption" ng-options="option.name for option in ctrl.availableOptions track by option.id"></select><br><div ng-show="ctrl.reloadIni == \'true\'"> Warning, saving this setting will clear your scan count</div></div>' +
    '<div ng-if="ctrl.availableOptions.length > 1"><div class="modal-body"><div ng-if="ctrl.settingID == \'ScanResponseField\'"><select multiple class="form-control" name="repeatSelect" id="repeatSelect" ng-model="ctrl.selectedOption" ng-options="option.name for option in ctrl.availableOptions track by option.id"></select><p><em>{{ctrl.info}}</em></p></div> <div ng-if="ctrl.settingID !== \'ScanResponseField\'"><select class="form-control" name="repeatSelect" id="repeatSelect" ng-model="ctrl.selectedOption" ng-options="option.name for option in ctrl.availableOptions track by option.id"></select><p><em>{{ctrl.info}}</em></p></div><br><div class="alert alert-warning" ng-show="ctrl.reloadIni == \'true\'"><strong>Warning!</strong> This setting requires a restart to take effect.</div></div>' +
   //'<div ng-show="ctrl.reloadIni == \'true\'"> Warning, saving this setting will clear your scan count</div>' +
   '<div class="modal-footer"><button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button><button class="btn btn-primary" ng-show="!settings.inptField.$error.required" type="button" ng-click="updateConfigObj(modelsrc)">Save</button></span></div></div>';
   // '<div ng-if="soundsrc"><div class="modal-body"> <select class="form-control" name="repeatSelect" id="repeatSelect" ng-model="ctrl.selectedOption" ng-options="option.name for option in ctrl.availableOptions track by option.id"></select></div>' +
   //'<div class="modal-footer"><button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button><button class="btn btn-primary" type="button" ng-click="updateConfigObj(modelsrc)">Save</button></span></div></div>';

    var scope = {
        modelsrc: '=modelsrc',
        soundsrc: '=soundsrc',
        ctrl: '=type',
        updateSetting: '&',
        updateConfig: '&',
        clearModel: '&'
    };

    var link = function (scope, element, attrs, ctrl) {
        //console.dir(scope.soundsrc)
        //console.dir(scope.modelsrc);



        //scope.$watch(function () { return scope.modelsrc; }, function (oldV, newV) {
        //    console.log(oldV)
        //        }, true)

        if (scope.ctrl.selectedOption) {
            if (scope.ctrl.settingID !== "ScanResponseField") {
                scope.ctrl.selectedOption = { id: scope.modelsrc};
            } else {
                var cleanStar = scope.modelsrc.replace(/\*/g, '"')
                cleanStar =  JSON.parse("[" + cleanStar + "]");
                var selectMulti = [];
                for (var i = 0; i < cleanStar.length; i++) {
                    selectMulti.push({ id: cleanStar[i] })
                }
                scope.ctrl.selectedOption = selectMulti;
            }

        }
        if (scope.soundsrc) {
            scope.ctrl.availableOptions = scope.soundsrc;
        }

        scope.clearModel = function () {
            scope.ctrl.settingValue = "";

            // Call main function in parent scope
            scope.updateConfig(scope.ctrl);
            scope.updateSetting(scope.ctrl);

            //scope.$watch('modelsrc', function (newValue, oldValue) {
            //    if (newValue)
            //        console.log(oldValue);
            //    modelsrc = oldValue;
            //}, true);
            //modelsrc = "hoy"
        }

        scope.updateConfigObj = function (objSrc) {
            // Change stuff here
            scope.ctrl.settingValue = objSrc;
  
            // Call main function in parent scope
            scope.updateConfig(scope.ctrl);
            scope.updateSetting(scope.ctrl);
        }
    };    
    return {
        require: '?myCtrl',
        scope: scope,
        template: template,
        link: link
    };


});
app.directive('customDci', function () {

    var template = '<div><div class="modal-body col-xs-12">DCI: ' +
   '<input type="text" class="form-control" ng-model="modelsrc.DCI" oninput="this.value = this.value.toUpperCase()">' +
   //'<div ng-if="ctrl.availableOptions.length > 1"><div class="modal-body"> <select class="form-control" name="repeatSelect" id="repeatSelect" ng-model="ctrl.selectedOption" ng-options="option.name for option in ctrl.availableOptions track by option.id"></select><br><div ng-show="ctrl.reloadIni == \'true\'"> Warning, saving this setting will clear your scan count</div></div>' +
   '<div>Good Scan Sound: <select class="form-control" name="repeatSelect" id="repeatSelect" ng-model="ctrl.selectedOptionGood" ng-options="option.name for option in ctrl.availableOptions1 track by option.id"></select></div> ' +
   '<div>Bad Scan Sound: <select class="form-control" name="repeatSelect2" id="repeatSelect2" ng-model="ctrl.selectedOptionBad" ng-options="option.name for option in ctrl.availableOptions2 track by option.id"></select></div> ' +
   //'<div>Background: <input type="text" name="color1" value="99cc00" class="form-control jscolor" ng-model="modelsrc.Custom.DCI_bkgd_color"></div>' +
   '<div>Background: <input type="text" class="form-control" color-picker color-picker-position="bottom" color-picker-model="modelsrc.Custom.DCI_bkgd_color" readonly="true" ng-style="{background:modelsrc.Custom.DCI_bkgd_color}"/> </div>' +
   '<div>Font Color: <input type="text" class="form-control" color-picker color-picker-position="bottom" color-picker-model="modelsrc.Custom.DCI_font_color" readonly="true" ng-style="{background:modelsrc.Custom.DCI_font_color}"/> </div>' +
   '<div>{{ctrl.info}}</div>' +
   //'<div ng-show="ctrl.reloadIni == \'true\'"> Warning, saving this setting will clear your scan count</div>' +
   '</div><div class="modal-footer"><button type="button" class="btn btn-secondary" data-dismiss="modal">Cancel</button><button class="btn btn-primary" type="button" ng-click="updateConfigObj(modelsrc.DCI, modelsrc.Custom.DCI_bkgd_color)">Save</button></span></div></div>';
    // '<div ng-if="soundsrc"><div class="modal-body"> <select class="form-control" name="repeatSelect" id="repeatSelect" ng-model="ctrl.selectedOption" ng-options="option.name for option in ctrl.availableOptions track by option.id"></select></div>' +
    //'<div class="modal-footer"><button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button><button class="btn btn-primary" type="button" ng-click="updateConfigObj(modelsrc)">Save</button></span></div></div>';

    var scope = {
        modelsrc: '=modelsrc',
        soundsrc: '=soundsrc',
        ctrl: '=type',
        updateSettingCstm: '&',
        currentIndex: '='
    };

    var link = function (scope, element, attrs, ctrl) {
        //console.dir(scope.soundsrc)

    

       
        //if (scope.modelsrc.GoodSound) {
        //    scope.$watch(function () { return scope.modelsrc; }, function (objSrc) {
        //        scope.ctrl.selectedOptionGood = { id: scope.modelsrc.GoodSound };
        //        scope.ctrl.selectedOptionBad = { id: scope.modelsrc.BadSound };
        //    }, true)
        //} else {

        //        scope.ctrl.selectedOptionGood = { id: "" };
        //        scope.ctrl.selectedOptionBad = { id: "" };
 
        //}

        if (scope.modelsrc) {
                    scope.ctrl.selectedOptionGood = { id: scope.modelsrc.GoodSound };
                    scope.ctrl.selectedOptionBad = { id: scope.modelsrc.BadSound };
            //console.log("modelsrc")

        } else {
            scope.modelsrc = { Section: "DCIConfig" + scope.currentIndex };
                    scope.ctrl.selectedOptionGood = { id: "" };
                    scope.ctrl.selectedOptionBad = { id: "" };
                    //console.log("no modelsrc")
        }

        if (scope.soundsrc) {
            scope.ctrl.availableOptions1 = scope.soundsrc;
            scope.ctrl.availableOptions2 = scope.soundsrc;

;
        }

        scope.updateConfigObj = function (objSrc) {



            // Change stuff here
            if (scope.modelsrc.Section) {
                scope.ctrl.section = scope.modelsrc.Section;

            } else {
                scope.ctrl.section = "DCIConfig" + scope.currentIndex;
            }
            scope.modelsrc.Section = "";
            
            //scope.ctrl.section = scope.modelsrc.Section;
            scope.ctrl.settingValue = objSrc;
            scope.ctrl.goodsound = scope.ctrl.selectedOptionGood.id;
            scope.ctrl.badsound = scope.ctrl.selectedOptionBad.id;
            scope.ctrl.background = scope.modelsrc.Custom.DCI_bkgd_color;
            scope.ctrl.font = scope.modelsrc.Custom.DCI_font_color;

            // Call main function in parent scope
            scope.updateSettingCstm(scope.ctrl);

        }

    };
    return {
        require: '?myCtrl',
        scope: scope,
        template: template,
        link: link
    };


});
